
/* Enumerations */

//Defines a type for a group of related values -- type safe

enum Direction {  // Defines a new type called Direction: 
   //Convention: capitalize first letter
   case North
   case South
   case East
   case West
}

var d = Direction.East
d = .South


switch d {
case Direction.North: print("North")
case .South: print("South")
default: print("Other")
}


enum Gender {
   case Male, Female
}








// Associated Values
enum SchoolGrade {
   case High(Int)
   case Middle(Int)
   case Elementary(Int, Gender)
}

var g = SchoolGrade.High(1)
g = .Elementary(3, .Male)

switch g {
case .Middle(let year):  print("Middle School year \(year)")
case .Elementary(2, let gender): print("Elementary Gender: \(gender)")
case let .Elementary(year, gender): print("\(year), \(gender)")
default: print("Other")
}







// Raw Values
enum Direct : Int{   // raw value type is Int
   case North = 2, South, East, West
}

Direct.West.rawValue
let d1 = Direct.East
d1.rawValue

// Automatically generated intilaizer
let d2 = Direct(rawValue: 5)  // Returns an optional
d2!    // Caution!

// Type of raw values can be:
//    Int, UInt, Float, Double, String, Character
enum Direct2 : String{   // raw value type is String
   case North="North", South="South", East="East", West="West"
}
Direct2.North.rawValue

// Enum, like struct, is value type

















