
/* Class and Structure */

class Person {
   var name:String = ""   // Properties
   var age:Int = -1
   func run() {}          // Methods
}

struct House {
   var streetNumber:String = ""
   var area:Int = -1
   func upgrade() {}     // Method
}

var p = Person()  // Default Initializer
p.name = "Bob"
p.age = 35
p.run()

var h = House()   // // Default Initializer
h.streetNumber = "234"
h.area = 1000
h.upgrade()



//Difference: Struct is value type, Class is reference type
h  // a struct
var h3 = h   // h3 is a copy of h
h3.streetNumber = "000"
h

p  // a class
var p3 = p   // p3 and p are referencing to the same object of Person
p3.name = "George"
p


//
let p5 = p  // constant reference: reference cannot be change, but the data can
//p5 = p3  // Error
p5.age = 99


let h5 = h       // constant value: value cannot be changed
//h5 = h3         // Error
//h5.area = 2000  // Error




func changeName(p:Person) {  // p doesn't have to be inout
   p.name = "John"
}
p
changeName(p)
p

func changeHouseName(inout h:House) {  // h is inout
   h.streetNumber = "111"
}
changeHouseName(&h)









// Equality is not defined for class and struct by default
//h == h2  // Error
//p == p3  // Error


// Equality for Class -- Idenity Operator

//if p !== p3 {
if p === p3 {   // Check if the two are referencing the same object
   print("p and p3 are same")
}

var p4 = Person()
p4.name = p.name
p4.age = p.age
if p === p4 {   // p and pc have the same content, but not same object
   print("p and p4 are same")
}

// It doesn't make sense for value type data to use
//if h2 === h3 {   // Won't compile.
//   println("h3 and h2 are same")
//}











// Who else is value type?

// The built-in data types are implemented with struct, there for are value types:
//  Int, UInt, Double, Float, Bool, String
//  Array, Dictionary, Tuple, Optional

let a1 = [2,3,4,5,6,7]
var a2 = a1  // A copy, but not necessary inefficient
a2.append(8)  // Now copying really happened

a2 == a1     // Operator == is defined for Arrays

// Who else is reference type?  Function




//Smaller difference: Struct has a member-wise initializer
var h2 = House(streetNumber: "23456", area: 1900)




// Variable must be initialized before being used
var x:Person
//x.name = "Bob"   // Error
x = Person()

var i:Int
//println(i)  // Error i is not initialized
i = 50

var o:Int?







