
/* Methods */

class Counter {
   var count = 0
   func increment() {
      self.count++   // self.count means the same
   }
   
   func incrementBy(amount:Int, times:Int) {
      self.count += amount * times
   }
   
   func incrementBy2(amount amount:Int, numberOfTimes times:Int) {
      count += amount * times
   }

   func incrementBy3(increAmount amount:Int, _ times:Int) {
                                       // _ is required here
      count += amount * times
   }
}


let c = Counter()
c.incrementBy(5, times: 7) // First parameter has only local parameter.
                           // Subsequent parameters have both local and external parameters
// similar to non-method functions' parameter with default value.

c.incrementBy2(amount: 6, numberOfTimes: 2)

c.incrementBy3(increAmount: 4, 8)

// Arguments has default external parameters:
// 1. Function parameters that have default values
// 2. All method parameters except the first parameter









// struct methods have 3 difference from class methods
struct Counter2 {   //1. value type's method cannot modify its own properties by default
   var count = 0
   
   mutating func increment() {  // same for enum
      self.count++
   }
   
   mutating func reBorn() {
      self = Counter2()       //2. Only struct and enum can do this
   }
}

var cs = Counter2()
cs.increment()
cs.count
cs.reBorn()
cs.count


let cs2 = Counter2()
//cs2.count = 5   // value type constant cannot change its properties
//cs2.increment()  // 3. value type constant cannot call mutating functions











// Type Method
class SomeClass {
   class func someTypeMethod() {
      // method implementation goes here
   }
}
SomeClass.someTypeMethod()


struct SomeStruct {
   static func someTypeMethod() {
      // method implementation goes here
   }
}
SomeStruct.someTypeMethod()


// enum methods are very similar to struct methods
enum SomeEnum {
   case one, two
   
   static func someTypeMethod() {}
   
   func someMethod() {}
   
   mutating func someMutatingMethod() {}
   
   init() {
      self = one   // self must be assigned
   }
}
SomeEnum.someTypeMethod()
let x = SomeEnum.one
x.someMethod()
//x.someMutatingMethod()  // Error

// enum can only have computed properties.









