

/* Inheritance */

// It can only be used for class, not for struct and enum

class Vehicle {
   var currentSpeed = 0
   let name = ""
   var name2 = ""
   func makeSound() {}
}

// Method Overriding
class Bike : Vehicle {
   override func makeSound() {
      print("Ding Ding, speed = \(currentSpeed)")
   }
}

let b  = Bike()
b.makeSound()


// Properties Overriding: overriding getter/setter
class Bike2 : Vehicle {
   override var currentSpeed:Int {
      get {
         return super.currentSpeed + 10  // You cannot access self.currentSpeed here
      }
      set {
         super.currentSpeed = newValue
      }
      // If you override the getter, you must override the setter
   }
   
   override var name2:String {  // name has to be var to be overridable
      get {                    // Computed properties can't be constant
         return "Bike"
      }
      set {
         super.name2 = newValue
      }
   }
}

let b2 = Bike2()
b2.currentSpeed
b2.name2


















// Overriding observer
class Truck : Vehicle {
   override var currentSpeed:Int {   // You cannot override setter here
      willSet {                      // because the observers are overridden
         print("speed wil be set to \(currentSpeed)")
      }
      didSet {
         print("speed has been set to \(currentSpeed)")
      }
   }
}
let t = Truck()
t.currentSpeed = 60


// Final
class Vehicle2 {
   final var currentSpeed = 0
   final func makeSound() {}
   final subscript(index:Int)->String { return ""}
}

final class Vehicle3 {  // Class cannot be inherited from
   var currentSpeed = 0
}









// Polymorphism
class Car: Vehicle {
   override func makeSound() {
      print("Bee Bee, speed = \(currentSpeed)")
   }
}

var a = [Bike(), Car(), Bike()]  // Array of Vehicle (Type Inference: finding common ancestor)

for v in a {
   v.makeSound()   // Polymorphism
}























