

/* Optional Chaining */

// Example from book:

class Residence {
   var numberOfRooms = 1
}

class Person {
   var age = 30
   var residence: Residence?
}
let me:Person? = Person()

me!.age  // runtime error if me is nil

if me != nil {
    me!.age
}

me?.age  // safe, returns an optional

me?.residence?.numberOfRooms // returns nil if either me or me?.residence is nil

// Optional Binding
if let num = me?.residence?.numberOfRooms {
   print("\(num)") // num is not optional
} else {
   print("Can't get number of room")
}






// Chaining with methods and subscripts
class Person2 {
   var residence: Residence?
   
   func buildHome() -> Residence? {
      return residence
   }
   
   subscript(name:String) -> Residence? {
      return residence
   }
}

var p:Person2? = Person2()
let n1 = p?.buildHome()?.numberOfRooms

let n2 = p?["Home"]?.numberOfRooms














// Optional chaining with Dictionary
var d:[String:Person] = [:]

d["Bob"]?.residence?.numberOfRooms



let d2 = ["Dummy" : d]

d2["Dummy"]?["Bob"]?.residence?.numberOfRooms






















