
/* Collection Type: Array */

// An array is an ordered list

let arrOfInt = [2,3,4]
var arrOfString = ["Bob", "Steve", "John"]
// All items must be of the same type


var a:[String] = []  // must be annotated

a.count
a.append("Apple")
"hello".characters.count
a.count // same func as String

a.isEmpty
















// Operators for array
a
a = a + ["Pear", "Banana"]
a += ["Orange"]

a[1]
//a[9]  // Runtime error

a[1...3]   // range operator
a[1..<3]

a.insert("Plum", atIndex: 2)
a[2]

a.removeAtIndex(2)  // returns the removed item
a

a.removeRange((0...1))
a

a.removeLast()
a
















// Iterating
a = ["apple", "banana", "plum", "orange"]

for item in a {
   print("\(item)")  
}

for item in a[1...2] {
   print("\(item)")  // same syntax as formatting strings
}

for x in a {
    print(x)
}

for (index, item) in a.enumerate() {
   print("index: \(index)  item: \(item)")
}


// Initializing
var a0:[Int] = []
var a1:Array<Int> = []
var a2 = [Int]()

var a4 = [Int](count: 5, repeatedValue: -1)

var a5:[[Int]] = []  // Multi-demension array
a5.append([2,3,4])













// Capacity
a4
a4.capacity  // capacity is not same as count
a4.append(2)
a4.append(3)  // memory reallocation
a4.count
a4.capacity  

// Array Memory Reallocation -- expensive
// 1. Allocate another trunk of memory
// 2. Copy data from old memory to new memory
// 3. Deallocate old memory
a4.reserveCapacity(20)  // count is 0, capacity >=20

a4.removeAll(keepCapacity: true) // to reuse a4
a4.capacity
a4.removeAll(keepCapacity: false)
a4.capacity


a
a = []  // Also deletes all items
         // Not keep capacity
a.capacity

var str:String = ""
str.reserveCapacity(1024)








// Array of tuples
var a7:[(Int,String)] = []
let mybrother = (23, "Bob")
a7.append(mybrother)
a7[0]


// Array of optionals
var a6:[Int?] = []
a6.append(3)
a6[0]

// Optional of optional
var x:Int?? = 9
x!
x!!




var aa:[Any] = []   // array of any type
aa.append(2)
aa.append("Bob")
var aa2:[AnyObject] = []  // array of any objects



























