

/* Collection Types: Dictionary */

var d = ["math":89, "chemistry":90, "physics":79]
// Dictionary of [String:Int]
var d2 = [3.4:true, 2.8:false, 5.6:true]

// fetching
d["math"]  // returns optional, unlike Array
let arr = [89, 90, 79]
arr[0]

d["music"]  // arr[9] is runtime error

d.count

// syntacs difference from tuple
let t = (math:89, chemistry:90, physics:79)
t.math  // returns value, not optional
// you cannot add/remove items into a tuple
















// Modifying

d["math"]
d["math"] = 70   // returns new value

d["chemistry"]
d.updateValue(100, forKey: "chemistry")
// returns old value
// It's convenient when you want to check old value

if d.updateValue(80, forKey: "music") == nil {
   print("music has no value before")
}

// Optional binding with dionary
if let myscore = d["math"] {
   // check if the item already exist
   print("math has a score: \(myscore)")
}



















// Deleting
d["math"] = nil  // deleted from dionary
d.removeValueForKey("chemistry") // returns old v


var d3 = d  // Duplicating, like Array
d3.removeAll(keepCapacity: true)
d3 = [:]  // Remove all items, not keeping capacity


// Iterating
for (myclass, myscore) in d {
   print("\(myclass) is \(myscore)")
}
// Note: dictionaries are unordered.


for x in d.keys {
   print("class name: \(x)")
}

for x in d.values {
   print("score: \(x)")
}














// Initializing 
var d1:[Int:String] = [:]
var d4 = [Int:String]()
var d5 = Dictionary<Int,String>()

d1[34] = "Bob"  // static typed
//d1["Bob"] = 34


// key must be hashable 
// (conforming to Hashable protocol)
32.hashValue
"Bob".hashValue
true.hashValue
false.hashValue

// To use your own type as key, you need to define .hashValue
// Hashable protocol:





















